﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.SilverlightEdition;
using ThinkGeo.MapSuite.Routing;

namespace RoutingInSilverlightDemo.Web
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                if (!SilverlightMapConnector1.ServerLayerOverlays.Contains("Austinstreets"))
                {
                    SilverlightMapConnector1.MapUnit = GeographyUnit.DecimalDegree;
                    //Note: you should add the Austinstreets data from MapSuite Routing install folder
                    ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(MapPath("~/app_data/Austinstreets.shp"));
                    worldLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad3;
                    worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                    ServerLayerOverlay layerOverlay = new ServerLayerOverlay("NativeServer");
                    layerOverlay.Layers.Add(worldLayer);

                    SilverlightMapConnector1.ServerLayerOverlays.Add("Austinstreets", layerOverlay);
                }

                string sourceText = Request.QueryString["source"];
                if (!string.IsNullOrEmpty(sourceText))
                {
                    string[] featureIds = sourceText.Split(',');
                    //Note: you should add the Austinstreets data from MapSuite Routing install folder
                    RoutingEngine routingEngine = new RoutingEngine(new RtgRoutingSource(MapPath("~/app_data/Austinstreets.rtg")), new ShapeFileFeatureSource(MapPath("~/app_data/Austinstreets.shp")));
                    RoutingResult result = routingEngine.GetRoute(featureIds[0], featureIds[1]);
                    Response.Clear();
                    Response.Write(result.Route.GetWellKnownText());
                    Response.End();
                }
            }

        }
    }
}
