﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.SilverlightEdition;
using System.Windows.Resources;
using System.Windows.Browser;
using System.Globalization;

namespace RoutingInSilverlightDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ServerLayerOverlay serverOverlay = new ServerLayerOverlay("NativeServer", "SilverlightMapConnector1");
            Map1.Overlays.Add(serverOverlay);

            InMemoryFeatureLayer layer = new InMemoryFeatureLayer();
            layer.InternalFeatures.Add(new Feature(-97.766061, 30.2982445));
            layer.InternalFeatures.Add(new Feature(-97.727325, 30.263861));
            layer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.Capital1;
            layer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Highway3;
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(layer);
            Map1.Overlays.Add("RoutingOverlay", overlay);

            Map1.ZoomTo(new PointShape(-97.736704, 30.2639355), 13);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            WebClient webClient = new WebClient();
            webClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(webClient_DownloadStringCompleted);
            webClient.DownloadStringAsync(GetLocationServiceUri("4226,8094"));
        }

        private static Uri GetLocationServiceUri(string sourceText)
        {
            string absolutePageUri = HtmlPage.Document.DocumentUri.AbsoluteUri;
            int index = absolutePageUri.LastIndexOf('/');
            if (index != -1)
            {
                absolutePageUri = absolutePageUri.Remove(index);
            }

            return new Uri(String.Format(CultureInfo.InvariantCulture, "{0}/Default.aspx?source={1}", absolutePageUri, sourceText));
        }

        void webClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            string wkt = e.Result;
            MultilineShape lineShape = new MultilineShape(wkt);
            ((InMemoryFeatureLayer)((LayerOverlay)Map1.Overlays["RoutingOverlay"]).Layers[0]).InternalFeatures.Add(new Feature(lineShape));

            Map1.Overlays["RoutingOverlay"].Refresh();
        }
    }
}
